unit HelloWorldMainFMX;

{$I RSDefines.inc}

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  {$IFDEF DELPHI18PLUS}FMX.StdCtrls,{$ENDIF}
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.ListBox, FMX.Layouts,
  FMX.Edit, FMX.Memo;

type
  TForm40 = class(TForm)
    Memo1: TMemo;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    eNum: TEdit;
    btnFillLB: TButton;
    btnFillMemo: TButton;
    Layout1: TLayout;
    lbOutput: TListBox;
    Splitter1: TSplitter;
    mmOutput: TMemo;
    cbModifyStrings: TCheckBox;
    cbUseUpdates: TCheckBox;
    Label1: TLabel;
    mmResults: TMemo;
    Layout2: TLayout;
    Layout3: TLayout;
    procedure btnFillLBClick(Sender: TObject);
    procedure btnFillMemoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure RunTest(const S: TStrings; InputStr: String; Count: Integer;
      ModifyStrings, UseBeginEndUpdate: Boolean);
  end;

var
  Form40: TForm40;

implementation

{$R *.fmx}

uses
  DateUtils;

procedure TForm40.btnFillLBClick(Sender: TObject);
begin
  RunTest(lbOutput.Items, Edit1.Text, StrToInt(eNum.Text), cbModifyStrings.IsChecked, cbUseUpdates.IsChecked);
end;

procedure TForm40.btnFillMemoClick(Sender: TObject);
begin
  RunTest(mmOutput.Lines, Edit1.Text, StrToInt(eNum.Text), cbModifyStrings.IsChecked, cbUseUpdates.IsChecked);
end;

procedure TForm40.RunTest(const S: TStrings; InputStr: String; Count: Integer; ModifyStrings,
  UseBeginEndUpdate: Boolean);
var
  i: Integer;
  StartTime: TDateTime;
  StopTime: TDateTime;
begin
  // note that the code uses a non-high precision timer (accurate up to 10 ms)
  // as I wanted the code to be portable between all versions of Delphi and
  // all platforms
  S.Clear;
  StartTime := Now;
  if UseBeginEndUpdate then S.BeginUpdate;
  try
    for i := 0 to Count - 1 do
    begin
      if ModifyStrings then
        S.Add(InputStr + IntToStr(i))
      else
        S.Add(InputStr);
    end;
  finally
    if UseBeginEndUpdate then S.EndUpdate;
    StopTime := Now;
  end;

  mmResults.Lines.Add('Added '+IntToStr(Count)+' strings in '+
    IntToStr(MilliSecondsBetween(StopTime, StartTime))+' ms');
end;

end.
