unit HelloWorldMainMobile;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Edit, FMX.ListBox,
  FMX.Layouts, FMX.StdCtrls, FMX.Memo;

type
  TForm41 = class(TForm)
    ToolBar1: TToolBar;
    Label1: TLabel;
    ToolBar2: TToolBar;
    lblResults: TLabel;
    ListBox1: TListBox;
    ListBoxItem1: TListBoxItem;
    ListBoxItem2: TListBoxItem;
    ListBoxItem3: TListBoxItem;
    Edit1: TEdit;
    eNum: TEdit;
    ListBox2: TListBox;
    lbiModifyStrings: TListBoxItem;
    lbiUseUpdates: TListBoxItem;
    btnFillLB: TButton;
    btnFillMemo: TButton;
    Layout1: TLayout;
    ListBoxGroupHeader1: TListBoxGroupHeader;
    mmOutput: TMemo;
    lbOutput: TListBox;
    procedure btnFillLBClick(Sender: TObject);
    procedure btnFillMemoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure RunTest( const S: TStrings; InputStr: String; Count: Integer; ModifyStrings, UseBeginEndUpdate: Boolean );
  end;

var
  Form41: TForm41;

implementation

{$R *.fmx}

Uses
  DateUtils;

procedure TForm41.btnFillLBClick(Sender: TObject);
begin
  lbOutput.Visible := True;
  mmOutput.Visible := False;
  RunTest(lbOutput.Items, Edit1.Text, StrToInt(eNum.Text), lbiModifyStrings.IsChecked, lbiUseUpdates.IsChecked);
end;

procedure TForm41.btnFillMemoClick(Sender: TObject);
begin
  lbOutput.Visible := False;
  mmOutput.Visible := True;
  RunTest(mmOutput.Lines, Edit1.Text, StrToInt(eNum.Text), lbiModifyStrings.IsChecked, lbiUseUpdates.IsChecked);
end;

procedure TForm41.RunTest(const S: TStrings; InputStr: String; Count: Integer; ModifyStrings,
  UseBeginEndUpdate: Boolean);
var
  i: Integer;
  StartTime: TDateTime;
  StopTime: TDateTime;
begin
  // note that the code uses a non-high precision timer (accurate up to 10 ms)
  // as I wanted the code to be portable between all versions of Delphi and
  // all platforms
  S.Clear;
  StartTime := Now;
  if UseBeginEndUpdate then S.BeginUpdate;
  try
    for i := 0 to Count - 1 do
    begin
      if ModifyStrings then
        S.Add(InputStr + IntToStr(i))
      else
        S.Add(InputStr);
    end;
  finally
    if UseBeginEndUpdate then S.EndUpdate;
    StopTime := Now;
  end;

  lblResults.Text := IntToStr(MilliSecondsBetween(StopTime, StartTime))+' ms';
end;

end.
