unit HelloWorldMainVCL;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls;

type
  TForm40 = class(TForm)
    lbOutput: TListBox;
    mmOutput: TMemo;
    Edit1: TEdit;
    btnFillLB: TButton;
    btnFillMemo: TButton;
    cbUseUpdates: TCheckBox;
    Memo2: TMemo;
    seNum: TSpinEdit;
    cbModifyStrings: TCheckBox;
    Label1: TLabel;
    mmResults: TMemo;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    Splitter1: TSplitter;
    procedure btnFillLBClick(Sender: TObject);
    procedure btnFillMemoClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure RunTest( const S: TStrings; InputStr: String; Count: Integer; ModifyStrings, UseBeginEndUpdate: Boolean );
  end;

var
  Form40: TForm40;

implementation

{$R *.dfm}
uses
  DateUtils;

procedure TForm40.btnFillLBClick(Sender: TObject);
begin
  RunTest(lbOutput.Items, Edit1.Text, seNum.Value, cbModifyStrings.Checked, cbUseUpdates.Checked);
end;

procedure TForm40.btnFillMemoClick(Sender: TObject);
begin
  RunTest(mmOutput.Lines, Edit1.Text, seNum.Value, cbModifyStrings.Checked, cbUseUpdates.Checked);
end;

procedure TForm40.RunTest(const S: TStrings; InputStr: String; Count: Integer; ModifyStrings,
  UseBeginEndUpdate: Boolean);
var
  i: Integer;
  StartTime: TDateTime;
  StopTime: TDateTime;
begin
  // note that the code uses a non-high precision timer (accurate up to 10 ms)
  // as I wanted the code to be portable between all versions of Delphi and
  // all platforms
  S.Clear;
  StartTime := Now;
  if UseBeginEndUpdate then S.BeginUpdate;
  try
    for i := 0 to Count - 1 do
    begin
      if ModifyStrings then
        S.Add(InputStr + IntToStr(i))
      else
        S.Add(InputStr);
    end;
  finally
    if UseBeginEndUpdate then S.EndUpdate;
    StopTime := Now;
  end;

  mmResults.Lines.Add('Added '+IntToStr(Count)+' strings in '+
    IntToStr(MilliSecondsBetween(StopTime, StartTime))+' ms');
end;

end.
